#!/usr/bin/perl -w
use warnings;
use DBI;


if (scalar(@ARGV) != 1 ) {
	print $#ARGV;
	print "usage: myscript.pl hostname \n";
	exit;
}


my $host = $ARGV[0];
my $dbhost = "<mysqlhost>";
my $table_procs = "procs";
my $table_cpu = "cpu";
my $table_mem = "mem";
my $user = "<mysqluser>";
my $pw = "<mysqlpassword>";


my $dbh = DBI->connect('DBI:mysql:nagvis_processes:debian:3306', $user, $pw, {RaiseError => 1});


# Cleans previous results
$sqlquery = "delete from cpu where cpu_machine='".$host."'";
$dbh->do($sqlquery);
$sqlquery = "delete from procs where procs_machine='".$host."'";
$dbh->do($sqlquery);
$sqlquery = "delete from mem where mem_machine='".$host."'";
$dbh->do($sqlquery);



my $timestamp = time;

my $lines_cpu = `snmpwalk -v2c -c public $host .1.3.6.1.2.1.25.5.1.1.1`;
my $lines_procs = `snmpwalk -v2c -c public $host .1.3.6.1.2.1.25.4.2.1.2`;
my $lines_mem = `snmpwalk -v2c -c public $host .1.3.6.1.2.1.25.5.1.1.2`;


# print $lines_cpu;

my @array_cpu = split('HOST-RESOURCES-MIB::hrSWRunPerfCPU.\d+\ =\ INTEGER:\ ',$lines_cpu);
my $reference_cpu = \@array_cpu;


$lines_procs =~ tr/"//d;

my @array_procs = split('HOST-RESOURCES-MIB::hrSWRunName.\d+\ =\ STRING:\ ',$lines_procs);
my $reference_procs=\@array_procs;


my @array_mem = split('HOST-RESOURCES-MIB::hrSWRunPerfMem.\d+\ =\ INTEGER:\ ',$lines_mem);
my $reference_mem = \@array_mem;


# INSERT processes INTO DATABASE
my $index = 0;
foreach $proc(@array_procs){
	if($index >= 1){
		my $index_string = $host."_".$index;
		my $myquery = "INSERT INTO procs VALUES('".$host."','".$index_string."',".$timestamp.",'".$proc."')";
		#  print $myquery."\n";
  		$dbh->do($myquery);
	}
  $index++;

}


#INSERT cpu INTO DATABASE
$index = 0;
foreach $cpu(@array_cpu){
  if($index>=1){
  my $index_string = $host."_".$index;
  $myquery = "INSERT INTO cpu VALUES ('".$host."','".$index_string."',".$timestamp.",".$cpu.")";
  print $myquery."\n";
  $dbh->do($myquery);
  }
  $index++;
}

#INSERT mem INTO DATABASE
$index = 0;
foreach $mem(@array_mem){
	if($index >= 1){
		my $index_string = $host."_".$index;
		$iIndex = index($mem, 'KBytes');
		$mem = substr($mem,0,$iIndex);
  		$myquery = "INSERT INTO mem VALUES ('".$host."','".$index_string."',".$timestamp.",".$mem.")";
  		#print $myquery."\n";
  		$dbh->do($myquery);
	}
  $index++;
}


print "/:OK |";
$dbh->disconnect();
exit(0);
